<template>
  <div class="barchart-wrapper">
    <div class="chart-container"></div>
  </div>
</template>

<script>
import * as _ from 'lodash'
import * as d3 from 'd3'
import Highcharts from 'highcharts'
import Drilldown from 'highcharts/modules/drilldown'
import UtilsService from '@/services/UtilsService'
if (typeof Highcharts === 'object') {
  Drilldown(Highcharts)
}
export default {
  props: {
    series: {
      type: Array,
      required: true,
    },
    title: {
      type: String,
      default: '',
    },
    suffix: {
      type: String,
      default: '',
    },
    type: {
      type: String,
      default: 'column',
    },
    labels: {
      type: Boolean,
      default: false,
    },
    plotMode: {
      type: String,
      default: 'normal',
      validator(value) {
        // The value must match one of these strings
        return ['normal', 'stacked', 'drilldown'].includes(value)
      },
    },
    colors: {
      type: Array,
      default() {
        return [
          // Default Highcharts colors
          '#7cb5ec',
          '#434348',
          '#90ed7d',
          '#f7a35c',
          '#8085e9',
          '#f15c80',
          '#e4d354',
          '#2b908f',
          '#f45b5b',
          '#91e8e1',
        ]
      },
    },
    height: {
      type: String,
      default: undefined,
    },
    width: {
      type: String,
      default: undefined,
    },
  },
  data() {
    return {}
  },
  computed: {},
  watch: {
    series: {
      handler: 'drawChart',
    },
    labels: {
      handler: 'toggleLabels',
    },
  },
  methods: {
    toggleLabels() {
      if (this.labels) {
        d3.select(this.$el)
          .selectAll('.highcharts-data-label,.highcharts-stack-labels')
          .style('display', null)
      } else {
        d3.select(this.$el)
          .selectAll('.highcharts-data-label,.highcharts-stack-labels')
          .style('display', 'none')
      }
    },
    drawChart() {
      const self = this
      let colors = this.colors
      if (
        this.plotMode === 'drilldown' &&
        this.colors.length === this.series.length
      ) {
        /**
         * This will zip colors and data, and then keep only the main categories' colors
         */
        const tmp = _.zip(this.colors, this.series)
        colors = _.uniqBy(tmp, (o) => o[1].name).map((o) => o[0])
      }
      Highcharts.setOptions({
        colors,
      })
      const $container = d3.select(this.$el).select('.chart-container').node()
      const hasTwoLevels =
        this.series[0] &&
        // eslint-disable-next-line no-prototype-builtins
        this.series[0].hasOwnProperty('sub') &&
        this.series[0].sub !== undefined
      let data = []
      const drilldownConfig = {
        series: [],
      }
      if (this.plotMode === 'drilldown') {
        const tmp = d3
          .nest()
          .key((o) => o.name)
          .entries(this.series)
          .map((o) => ({
            name: o.key,
            data: o.values,
            colorByPoint: true,
          }))
        data = [
          {
            name: '',
            colorByPoint: true,
            data: tmp.map((o) => ({
              name: o.name,
              y:
                this.plotMode === 'drilldown' && this.suffix === '%'
                  ? d3.mean(o.data, (d) => d.total)
                  : d3.sum(o.data, (d) => d.y),
              drilldown: o.name.toLowerCase().split(' ').join('_'),
            })),
          },
        ]
        drilldownConfig.series = tmp.map((o) => ({
          id: o.name.toLowerCase().split(' ').join('_'),
          data: o.data.map((d) => ({
            name: d.sub,
            y: d.y,
          })),
        }))
      } else {
        data = d3
          .nest()
          .key((o) => (hasTwoLevels ? o.sub : ''))
          .entries(this.series)
          .map((o) => {
            const obj = {
              name: o.key,
              data: o.values,
            }
            if (!hasTwoLevels) {
              obj.colorByPoint = true
            }
            return obj
          })
      }
      const stacked = this.plotMode === 'stacked'
      const xAxisConfig = { type: 'category' }
      const yAXisConfig = {
        title: {
          text: `Total ${this.title ? this.title.toLowerCase() : ''}`,
        },
      }
      if (stacked) {
        yAXisConfig.stackLabels = {
          enabled: true,
          formatter() {
            return !self.suffix
              ? `${UtilsService.formatNumber(this.total, 2)}`
              : ''
          },
        }
      } else {
        yAXisConfig.labels = {
          formatter() {
            return `${UtilsService.formatNumber(this.value)}${self.suffix}`
          },
        }
      }
      const plotOptionsConfig = {}
      if (stacked) {
        plotOptionsConfig.column = {
          stacking: this.suffix === '%' ? 'percent' : 'normal',
          dataLabels: {
            enabled: true,
            formatter() {
              return `${UtilsService.formatNumber(this.point.y)}${self.suffix}`
            },
          },
        }
      } else {
        plotOptionsConfig.series = {
          borderWidth: 0,
          dataLabels: {
            enabled: true,
            formatter() {
              return `${UtilsService.formatNumber(this.point.y)}${self.suffix}`
            },
          },
        }
      }
      const wholeConfig = {
        chart: {
          type: this.type ? this.type : 'column',
          height: this.height,
          width: this.width,
        },
        title: {
          text: this.title,
        },
        xAxis: xAxisConfig,
        yAxis: yAXisConfig,
        legend: {
          enabled: stacked,
        },
        plotOptions: plotOptionsConfig,
        tooltip: {
          headerFormat: '<span style="font-size:11px">{series.name}</span><br>',
          pointFormatter() {
            return `<span style="color:${this.color}">${
              this.name
            }</span>: <b>${UtilsService.formatNumber(this.y, 2)}${self.suffix}`
          },
        },
        series: data,
        drilldown: drilldownConfig,
      }
      // Create the chart
      Highcharts.chart($container, wholeConfig)
      this.toggleLabels()
    },
  },
  render(createElement) {
    return createElement('div')
  },
}
</script>

<style></style>
